package games.sudoku;

import utilities.StatisticalSummary;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 24-Jan-2006
 * Time: 16:54:43
 * To change this template use File | Settings | File Templates.
 */
public class AverageDistance {

    final static boolean swapMetric = false;

    final static int cases = 10000;

    public static void main (String[] args) throws Exception {
        int[] grid1 = Sudoku.readGrid ("grids/easy1.txt");
        int[] grid2 = Sudoku.readGrid ("grids/easy1.txt");
        Initializer initializer = new NaiveInitializer ();
        //Initializer initializer = new RowCompletionInitializer ();
        boolean[] fixed = Sudoku.getFixedPositions (grid1);
        initializer.initializeGrid (fixed, grid1, 3);
        initializer.initializeGrid (fixed, grid2, 3);
        StatisticalSummary ss = new StatisticalSummary ();
        StatisticalSummary fitsum = new StatisticalSummary ();
        //RowPermuter rowPermuter = new RowPermuter ();
        FitnessFunction fitnessFunction = new SimonsFitnessFunction ();
        for (int i = 0; i < cases; i++) {
            initializer.initializeGrid (fixed, grid1, 3);
            initializer.initializeGrid (fixed, grid2, 3);
            //rowPermuter.permute (fixed, grid1, 9);
            //rowPermuter.permute (fixed, grid2, 9);
            int distance = (swapMetric ? Sudoku.swapDistance (grid1, grid2, 9) : Sudoku.hammingDistance (grid1, grid2));
            ss.add (distance);
            fitsum.add (fitnessFunction.evaluate (grid1, 3));
        }
        System.out.println ("Distance: \n" + ss);
        System.out.println ("Fitness: \n" + fitsum);
    }
}
