package games.sudoku;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 13-Oct-2005
 * Time: 17:11:22
 * To change this template use File | Settings | File Templates.
 */
public class CrossoverValidator {

    public static void main (String[] args) throws Exception {
        int boxSize = 3;
        int rowLength = boxSize * boxSize;
        Crossover crossover = new UniformSwapCrossover ();
        Mutator mutator = new RowSwapMutator ();
        Initializer initializer = new RowCompletionInitializer ();
        int[] parent1 = Sudoku.readGrid ("grids/easy1.txt");
        Sudoku.printGrid (System.out, parent1);
        Sudoku.printTotalOccurences (parent1);
        int[] parent2 = Sudoku.readGrid ("grids/easy1.txt");
        boolean[] fixed = Sudoku.getFixedPositions (parent1);
        Sudoku.printFixedGrid (System.out, fixed);
        initializer.initializeGrid (fixed, parent1, boxSize);
        initializer.initializeGrid (fixed, parent2, boxSize);
        Sudoku.printGrid (System.out, parent1);
        Sudoku.printTotalOccurences (parent1);
        /*for (int i = 0; i < 100; i++) {
            mutator.mutate (fixed, parent2, boxSize);
        } */
        RowPermuter rowPermuter = new RowPermuter ();
        rowPermuter.permute (fixed, parent2, rowLength);
        Sudoku.printGrid (System.out, parent2);
        Sudoku.printTotalOccurences (parent1);
        int[] child = crossover.doCrossover (fixed, parent1, parent2, boxSize);
        Sudoku.printGrid (System.out, child);
        Sudoku.printTotalOccurences (child);
        printSwapDistances (parent1, parent2, rowLength);
        printSwapDistances (parent2, parent1, rowLength);
        printSwapDistances (parent1, child, rowLength);
        printSwapDistances (parent2, child, rowLength);
    }

    public static void printSwapDistances (int[] grid1, int[] grid2original, int rowLength) {
        int[] grid2 = new int[grid2original.length];
        System.arraycopy (grid2original, 0, grid2, 0, grid2.length);
        System.out.print ("Swap distances ");
        int sum = 0;
        for (int i = 0; i < rowLength; i++) {
            int swapDistance = Sudoku.swapDistance (grid1, grid2, i * rowLength, rowLength);
            System.out.print (swapDistance + " ");
            sum += swapDistance;
        }
        System.out.println (", total: " + sum);
    }
}
