package games.sudoku;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 12-Oct-2005
 * Time: 18:50:12
 * To change this template use File | Settings | File Templates.
 */
class OneCycleCrossover implements Crossover {

    boolean[] mask;

    public int[] doCrossover (boolean[] fixed, int[] parent1, int[] parent2, int boxSize) {
        int[] child = new int[fixed.length];
        int rowLength = boxSize * boxSize;
        if (mask == null) {
            mask = new boolean[rowLength];
        }

        for (int i = 0; i < rowLength; i++) {
            crossoverOneRow (parent1, parent2, child, i * rowLength, rowLength);
        }
        return child;
    }

    private void crossoverOneRow (int[] parent1, int[] parent2, int[] child, int offset, int rowLength) {
        clear (mask);
        // Take the first element of child from parent1
        int current = offset;
        child[offset] = parent1[offset];
        mask[0] = true;

        while(parent2[current] != parent1[offset]) {
            for(int i=offset;  i < offset+rowLength; i++) {
                if(parent1[i] == parent2[current]) {
                    child[i]=parent1[i];
                    mask[i - offset] = true;
                    current = i;
                    break;
                }
            }
        }

        for(int i=0; i < mask.length; i++) {
            if (mask[i] == false) {
                child[i + offset] =  parent2[i + offset];
            }
            else {
                child[i + offset] =  parent1[i + offset];
            }
        }
    }

    private void clear (boolean[] array) {
        for (int i = 0; i < array.length; i++) {
            array[i] = false;
        }
    }

}
