package games.sudoku;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 22-Nov-2005
 * Time: 14:57:29
 * To change this template use File | Settings | File Templates.
 */

public class ExponentialProbabilityNaiveMutator implements Mutator {

    int oldValue;
    int[] savedGrid = null;
    private double probability = 0.8;

    public void setMutationRate (double rate) {
        probability = rate;
    }

    public int[] mutate (boolean[] fixed, int[] grid, int boxSize) {
        if (savedGrid == null) {
            savedGrid = new int[grid.length];
        }
        System.arraycopy (grid, 0, savedGrid, 0, grid.length);
        while (Math.random () < probability) {
            onePointMutation (fixed, grid, boxSize);
        }
        return grid;
    }

    public void onePointMutation (boolean[] fixed, int[] grid, int boxSize) {
        int position;
        do {
            position = (int) (Math.random () * grid.length);
        } while (fixed[position]);
        oldValue = grid[position];
        grid[position] = (int) (Math.random () * 9) + 1;

    }

    public int[] reverseLastMutation (boolean[] fixed, int[] grid, int boxSize) {
        System.arraycopy (savedGrid, 0, grid, 0, grid.length);
        return grid;
    }
}
