package games.sudoku;

import java.util.List;
import java.util.LinkedList;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 14-Oct-2005
 * Time: 17:38:14
 * To change this template use File | Settings | File Templates.
 */
public class ExponentialProbabilityRowSwapMutator implements Mutator {

    int[] savedGrid = null;
    int firstPosition = 0;
    int secondPosition = 0;
    private double probability = 0.8;

    public void setMutationRate (double rate) {
        probability = rate;
    }

    public int[] mutate (boolean[] fixed, int[] grid, int boxSize) {
        if (savedGrid == null) {
            savedGrid = new int[grid.length];
        }
        // save old grid
        System.arraycopy (grid, 0, savedGrid, 0, grid.length);
        int rowlength = boxSize * boxSize;
        while (Math.random () < probability) {
            int whichRow = (int) (Math.random () * rowlength);
            firstPosition = (whichRow * rowlength) + randomPositionInRow (whichRow, fixed, rowlength);
            secondPosition = (whichRow * rowlength) + randomPositionInRow (whichRow, fixed, rowlength);
            swap (grid, firstPosition, secondPosition);
        }

        return grid;

    }

    public int[] reverseLastMutation (boolean[] fixed, int[] grid, int boxSize) {
        System.arraycopy (savedGrid, 0, grid, 0, grid.length);
        return grid;
    }

    private int randomPositionInRow (int whichRow, boolean[] fixed, int rowlength) {
        int position;
        do {
            position = (int) (Math.random () * rowlength);
        } while (fixed[(whichRow * rowlength) + position]);
        return position;
    }


    public static void swap(int[] grid, int i, int j) {
        //System.out.println ("Swapping " + i + " and " + j);
        int tmp = grid[i];
        grid[i] = grid[j];
        grid[j] = tmp;
    }

}
