package games.sudoku;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 16-Oct-2005
 * Time: 19:39:27
 * To change this template use File | Settings | File Templates.
 */
public class MultiCycleCrossover implements Crossover {

    int[] mask;

    public int[] doCrossover (boolean[] fixed, int[] parent1, int[] parent2, int boxSize) {
        int[] child = new int[fixed.length];
        int rowLength = boxSize * boxSize;
        if (mask == null) {
            mask = new int[rowLength];
        }

        for (int i = 0; i < rowLength; i++) {
            crossoverOneRow (parent1, parent2, child, i * rowLength, rowLength);
        }
        return child;
    }

    private void crossoverOneRow (int[] parent1, int[] parent2, int[] child, int offset, int rowLength) {
        clear (mask);
        // Take the first element of child from parent1
        int current = offset;
        child[offset] = parent1[offset];

        for (int scan = offset; scan < offset + rowLength; scan++) {
            if (mask[scan - offset] == 0) {
                current = scan;
                int parent = 1 + ((int) (Math.random () * 2));
                mask[scan - offset] = parent;
                //System.out.print ("1");
                while(parent2[current] != parent1[scan]) {
                    //System.out.print ("2");
                    for(int i = offset;  i < offset+rowLength; i++) {
                        //System.out.print ("3");
                        if(parent1[i] == parent2[current]) {
                            child[i]=parent1[i];
                            mask[i - offset] = parent;
                            current = i;
                            break;
                        }
                    }
                }
            }
        }
        for(int i=0; i < mask.length; i++) {
            if (mask[i] == 1) {
                child[i + offset] =  parent1[i + offset];
            }
            else {
                child[i + offset] =  parent2[i + offset];
            }
        }
    }

    private void clear (int[] array) {
        for (int i = 0; i < array.length; i++) {
            array[i] = 0;
        }
    }
}
