package games.sudoku;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 12-Oct-2005
 * Time: 00:20:50
 * To change this template use File | Settings | File Templates.
 */
public class PMXCrossover implements Crossover {

    int[] child1;
    int[] child2;

    public int[] doCrossover (boolean[] fixed, int[] grid1, int[] grid2, int boxSize) {
        child1 = new int[grid1.length];
        child2 = new int[grid2.length];
        int rowLength = boxSize * boxSize;
        int length = rowLength * rowLength;
        System.arraycopy (grid1, 0, child1, 0, length);
        System.arraycopy (grid2, 0, child2, 0, length);
        for (int i = 0; i < rowLength; i++)  {
            crossOverOneRow (rowLength, rowLength * i);
        }
        return child1;
    }

    private void crossOverOneRow (int rowLength, int offset) {
        // Start of the actual algorithm
        //  N B the locus arrays are too large, but position zero in
        // these array will never be used. Will it?
        int[] locus1 = new int[rowLength + 1];
        int[] locus2 = new int[rowLength + 1];
        for (int i = 0; i < rowLength; i++) {
            locus1[child1[offset + i]]=i;
            locus2[child2[offset + i]]=i;
        }
        int x_point1 = randomInt (0, rowLength);
        int x_point2 = randomInt (0, rowLength);
        if ( x_point1 > x_point2 ) {
            int temp = x_point1;
            x_point1 = x_point2;
            x_point2 = temp;
        }
        //System.out.println ("Crossover at row " + (offset / rowLength) + " is at " + x_point1 + " and " + x_point2);
        //printArray (locus1);
        //printArray (locus2);
        for (int i = x_point1; i < x_point2; i++) {
            // The symbols to be swapped
            int s1 = child1[offset + i];
            int s2 = child2[offset + i];
            // Swap symbols in child1
            child1[offset + locus1[s1]] = s2;
            child1[offset + locus1[s2]] = s1;
            // Swap loci in child1
            swap (locus1, s1, s2);
            // Swap symbols in child2
           // child2[offset + locus2[s1]] = s2;
           // child2[offset + locus2[s2]] = s1;
            // Swap loci in child2
           // swap (locus2, s1, s2);
        }
    }

    public static void swap(int[] grid, int i, int j) {
        int tmp = grid[i];
        grid[i] = grid[j];
        grid[j] = tmp;
    }

    private int randomInt (int start, int length) {
        return start + (int) (Math.random () * length);
    }

    private void printArray (int[] array) {
        for (int i = 0; i < array.length; i++)
            System.out.print (array[i] + " ");
        System.out.println ();
    }
}

/*
    private void crossOverOneRow (int[] parent1, int[] parent2, int[] child, int rowLength, int offset) {
        // Start of the actual algorithm
        int[] locus1 = new int[rowLength];
        int[] locus2 = new int[rowLength];
        for (int i = 0; i < rowLength; i++) {
            locus1[child1[offset + i] - 1]=i;
            locus2[child2[offset + i] - 1]=i;
        }
        int x_point1 = randomInt (0, rowLength);
        int x_point2 = randomInt (0, rowLength);
        if ( x_point1 > x_point2 ) {
            int temp = x_point1;
            x_point1 = x_point2;
            x_point2 = temp;
        }
        System.out.println ("Crossover at row " + (offset / rowLength) + " is at " + x_point1 + " and " + x_point2);
        for (int i = x_point1; i < x_point2; i++) {
            // The symbols to be swapped
            int s1 = child1[offset + i];
            int s2 = child2[offset + i];
            // Swap symbols in child1
            child1[offset + locus1[s1 - 1]] = s2;
            child1[offset + locus1[s2 - 1]] = s1;
            // Swap loci in child1
            swap (locus1, s1 - 1, s2 - 1);
            // Swap symbols in child2
            child2[offset + locus2[s1 - 1]] = s2;
            child2[offset + locus2[s2 - 1]] = s1;
            // Swap loci in child2
            swap (locus2, s1 - 1, s2 - 1);
        }
    }
*/