package games.sudoku;

import javax.swing.*;
import java.util.List;
import java.util.StringTokenizer;
import java.util.LinkedList;
import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.FileReader;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 21-Nov-2005
 * Time: 17:04:40
 * To change this template use File | Settings | File Templates.
 */
public class Plot extends JFrame {

    private List<double[]> history;
    int xScale = 5;
    Dimension dimension = new Dimension (800, 800);

    public static void main (String[] args) {
        try {
            List<double []> history = new LinkedList<double[]> ();
            BufferedReader reader = new BufferedReader (new FileReader ("history.txt"));
            while (reader.ready ()) {
                String string = reader.readLine ();
                StringTokenizer st = new StringTokenizer (string, " ");
                double[] values = new double[st.countTokens ()];
                int i = 0;
                while (st.hasMoreTokens ()) {
                    values[i] = Double.parseDouble (st.nextToken ());
                    i++;
                }
                history.add (values);
            }
            Plot plot = new Plot (history);
            plot.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
            plot.setVisible (true);
        }
        catch (Exception e) {
            e.printStackTrace ();
        }
    }

    public Plot (List<double[]> history) {
        this.history = history;
        xScale = (dimension.width / history.size ());
        this.getContentPane ().add (new PlotPanel ());
        this.pack ();
        this.setSize (dimension.width + 50, dimension.height + 50);
    }

    class PlotPanel extends JPanel {
        public void paintComponent (Graphics g) {
            g.setColor (Color.WHITE);

            g.fillRect (0, 0, dimension.width, dimension.height);
            g.setColor (Color.LIGHT_GRAY);
            for (int i = 0; i < dimension.getHeight (); i = i + 20) {
                g.drawLine (0, dimension.height - i, dimension.width, dimension.height - i);
            }
            // plot max fitness
            plotLine (g, Color.BLACK, 0);
            // plot average fitness
            plotLine (g, Color.RED, 1);
            // plot distance from solution
            plotLine (g, Color.BLUE, 2);
            // plot average distance
            plotLine (g, Color.GREEN, 3);
        }

        private void plotLine (Graphics g, Color color, int index) {
            int where = 0;
            int lastY = 0;
            g.setColor (color);
            for (double[] values : history) {
                if (where == 0) {
                    lastY = (int) values[index];
                }
                else {
                    g.drawLine ((where - 1) * xScale, dimension.height - lastY, where * xScale,
                            dimension.height - (int) values[index]);
                    lastY = (int) values[index];
                }
                where++;
            }
        }
    }



}
