package games.sudoku;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 19-Oct-2005
 * Time: 16:09:39
 * To change this template use File | Settings | File Templates.
 */
public class PopulationMeasures {

    public static int thoroughAverageMeanDistance (int[][] population, int boxSize) {
        int rowLength = boxSize * boxSize;
        long sum = 0;
        for (int i = 0; i < population.length; i++) {
            for (int j = 0; j < population.length; j++) {
                sum += Sudoku.swapDistance (population[i], population[j], rowLength);
            }
        }
        return (int) (sum / (population.length * population.length));
    }

    public static int sampledAverageMeanDistance (int[][] population, int boxSize) {
        if (population.length == 1) {
            return 0;
        }
        int rowLength = boxSize * boxSize;
        final int numberOfSamples = Math.min (100, population.length);
        long sum = 0;
        for (int i = 0; i < numberOfSamples; i++) {
            int[] first = population[(int) (Math.random () * population.length)];
            int[] second = population[(int) (Math.random () * population.length)];
            sum += Sudoku.swapDistance (first, second, rowLength);
        }
        return (int) (sum / (numberOfSamples));
    }

}
