package games.sudoku;

import java.util.Random;

/**
 * Created by IntelliJ IDEA.
 * User: sml
 * Date: 05-Oct-2005
 * Time: 10:26:45
 * To change this template use File | Settings | File Templates.
 */
public class RandHill {

    static int size = SimonsSudoku.size;
    static Random r = new Random();
    static SimonsSudoku s = new SimonsSudoku();

    public static void main(String[] args) {
        int[] grid = makeGrid();
        System.out.println("Fitness = " + s.fitness(grid));
        // swap some elements
        randGrid(grid, 1000);
        System.out.println(s.fitness(grid));
        int maxEvals = 100000;
        //ElapsedTimer t = new ElapsedTimer();
        int sol = randHillBitFlip(grid, maxEvals);
        // int sol = randHill(grid, maxEvals);
        System.out.println("Final fitness: " + sol);
        Sudoku.printGrid(System.out, grid);
        //System.out.println(t);
    }

    public static void randGrid(int[] grid, int nSwaps) {
        for (int i=0; i<nSwaps; i++) {
            int a = r.nextInt(grid.length);
            int b = r.nextInt(grid.length);
            SimonsSudoku.swap(grid, a, b);
        }
    }

    public static int randHill(int[] grid, int maxEvals) {
        int f = s.fitness(grid);
        for (int i=0; i<maxEvals; i++) {
            int a = r.nextInt(grid.length);
            int b = r.nextInt(grid.length);
            Sudoku.swap(grid, a, b);
            int cur = s.fitness(grid);
            if (cur > f) {
                f = cur;
                System.out.println(i + "\t " + f);
            }
            // if equal do nothing - just accept the change
            // otherwise revert it
            if (cur < f) {
                Sudoku.swap(grid, a, b);
            }
        }
        return f;
    }

    public static int randHillBitFlip(int[] grid, int maxEvals) {
        int f = s.fitness(grid);
        for (int i=0; i<maxEvals; i++) {
            // make the change at p
            int p = r.nextInt(grid.length);
            int val = grid[p];
            grid[p] = 1 + r.nextInt(size);
            int cur = s.fitness(grid);
            if (cur > f) {
                f = cur;
                System.out.println(i + "\t " + f);
            }
            // if equal do nothing - just accept the change
            // otherwise revert it
            if (cur < f) {
                // revert to old value
                grid[p] = val;
            }
        }
        return f;
    }

    public static int[] makeGrid() {
        // returns a grid with the n of each number 1..n
        int[] x = new int[size*size];
        int ix = 0;
        for (int i=1; i<= size; i++) {
            for (int j=1; j<= size; j++) {
                x[ix++] = j;
            }
        }
        return x;
    }
}
