package games.sudoku;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 11-Oct-2005
 * Time: 16:16:04
 * To change this template use File | Settings | File Templates.
 */
public class RowCompletionInitializer implements Initializer {

    public int[] initializeGrid (boolean[] fixed, int[] grid, int boxSize) {
        int rowlength = boxSize * boxSize;
        boolean[] takenValues = new boolean[rowlength];
        for (int i = 0; i < rowlength; i++) {
            //System.out.println ("row " + i);
            resetArray (takenValues);
            int offset = rowlength * i;
            // Check which numbers are already taken by fixed numbers
            for (int j = 0; j < rowlength; j++) {
                if (fixed[offset + j]) {
                    takenValues[grid[offset + j] - 1] = true;
                }
            }
            //printArray (takenValues);
            //printArray (grid, offset, rowlength);
            // Fill the row with the missing numbers
            int currentValue = 0;
            for (int j = 0; j < rowlength; j++) {
                //System.out.println (j + " " + currentValue);
                while (takenValues[currentValue] && currentValue < rowlength -1 )
                    currentValue++;
                if (!fixed[offset + j]) {
                    grid[offset + j] = currentValue + 1;
                    takenValues[currentValue] = true;
                }
                //printArray (grid, offset, rowlength);
            }
            //printArray (takenValues);
            //printArray (grid, offset, rowlength);
        }
        return grid;
    }

    private void resetArray (boolean[] array) {
        for (int i = 0; i < array.length; i++) {
            array[i] = false;
        }
    }

    private void printArray (boolean[] array) {
        for (int i = 0; i < array.length; i++) {
            System.out.print (array[i] ? "*" : "-");
        }
        System.out.println ();
    }

    private void printArray (int[] array, int start, int length) {
        for (int i = start; i < start + length; i++) {
            System.out.print (array[i] + " ");
        }
        System.out.println ();
    }
}

