package games.sudoku;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 14-Oct-2005
 * Time: 17:20:08
 * To change this template use File | Settings | File Templates.
 */
public class RowPermuter {

    public void permute (boolean[] fixed, int[] grid, int rowLength) {
        for (int row = 0; row < rowLength; row++) {
            permuteRow (fixed, grid, row * rowLength, rowLength);
        }

    }

    private void permuteRow (boolean[] fixed, int[] grid, int offset, int rowLength)  {
        for (int i = offset; i < offset + rowLength; i++) {
            if (!fixed[i]) {
                swap(grid, i, nonFixedRandom (fixed, offset, rowLength));
            }
        }
    }

    private int nonFixedRandom (boolean[] fixed, int offset, int rowLength) {
        int pos;
        do {
            pos = offset + (int) (Math.random () * rowLength);
        } while (fixed[pos]);

        return pos;
    }

    public static void swap(int[] grid, int i, int j) {
        int tmp = grid[i];
        grid[i] = grid[j];
        grid[j] = tmp;
    }

}
