package games.sudoku;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 10-Oct-2005
 * Time: 17:24:54
 * To change this template use File | Settings | File Templates.
 */
public class RowSwapMutator implements Mutator {

    int firstPosition = 0;
    int secondPosition = 0;

    public void setMutationRate (double rate) {
        //dummy
    }

    public int[] mutate (boolean[] fixed, int[] grid, int boxSize) {
        int rowlength = boxSize * boxSize;
        int whichRow = (int) (Math.random () * rowlength);
        firstPosition = (whichRow * rowlength) + randomPositionInRow (whichRow, fixed, rowlength);
        secondPosition = (whichRow * rowlength) + randomPositionInRow (whichRow, fixed, rowlength);
        swap (grid, firstPosition, secondPosition);
        return grid;
    }

    public int[] reverseLastMutation (boolean[] fixed, int[] grid, int boxSize) {
        swap (grid, firstPosition, secondPosition);
        return grid;
    }

    private int randomPositionInRow (int whichRow, boolean[] fixed, int rowlength) {
        int position;
        do {
            position = (int) (Math.random () * rowlength);
        } while (fixed[(whichRow * rowlength) + position]);
        return position;
    }


    public static void swap(int[] grid, int i, int j) {
        //System.out.println ("Swapping " + i + " and " + j);
        int tmp = grid[i];
        grid[i] = grid[j];
        grid[j] = tmp;
    }
}
