package games.sudoku;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 10-Oct-2005
 * Time: 19:56:18
 * To change this template use File | Settings | File Templates.
 */
public class SimonsFitnessFunction implements FitnessFunction {

    //static int size = 9;
    //static int subGrid = 3;
    private int size;
    private int subGrid;
    private int[] match;

    public double evaluate (int[] grid, int boxSize) {
        subGrid = boxSize;
        size = subGrid * subGrid;
        if (match == null) {
            match = new int[size + 1];
        }

        // check all the rows and columns
        int tot = 0;
        for (int i = 0; i < size; i++) {
            // check a column
            tot += checkLine(grid, i, size);
            // check a row
            tot += checkLine(grid, i * size, 1);
        }
        // now check the sub-grids
        for (int x = 0; x < size; x += subGrid) {
            for (int y = 0; y < size; y += subGrid) {
                tot += checkBox(grid, x, y);
            }
        }
        return tot;
    }

    public int checkLine(int[] grid, int start, int diff) {
        int tot = 0;
        resetMatch();
        for (int i = 0; i < size; i++) {
            int val = grid[start];
            if (match[val] == 0) {
                match[val] = 1;
                tot++;
            }
            start += diff;
        }
        return tot;
    }

    public int checkBox(int[] grid, int x, int y) {
        int tot = 0;
        resetMatch();
        for (int i = x; i < x + subGrid; i++) {
            for (int j = y; j < y + subGrid; j++) {
                int val = grid[i + size * j];
                if (match[val] == 0) {
                    match[val] = 1;
                    tot++;
                }
            }
        }
        return tot;
    }

    public void resetMatch() {
        match[0] = 1;
        for (int i = 1; i < match.length; i++) {
            match[i] = 0;
        }
    }
}
