package games.sudoku;

import java.util.Random;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 11-Oct-2005
 * Time: 13:07:52
 * To change this template use File | Settings | File Templates.
 */
public class SimonsHillClimber implements EA {

    Random r = new Random ();
    int[] grid = null;
    int size;
    int boxSize;
    int f;
    final FitnessFunction fitnessFunction;
    private boolean changeSinceLastGeneration;

    public SimonsHillClimber (FitnessFunction fitnessFunction) {
        this.fitnessFunction = fitnessFunction;
    }

    public void initialize (boolean[] fixed, int[] grid, int boxSize) {
        this.grid = grid;
        this.boxSize = boxSize;
        this.size = boxSize * boxSize;
    }

    public double getMaximumFitness () {
        return f;
    }

    public double getAverageFitness () {
        return f;
    }

    public void oneMoreGeneration () {
        int p = r.nextInt(grid.length);
            int val = grid[p];
            grid[p] = 1 + r.nextInt(size);
            int cur = (int) fitnessFunction.evaluate(grid, boxSize);
            if (cur > f) {
                f = cur;
                //System.out.println(i + "\t " + f);
            }
            // if equal do nothing - just accept the change
            // otherwise revert it
            if (cur < f) {
                // revert to old value
                grid[p] = val;
                changeSinceLastGeneration = false;
            }
            else {
                changeSinceLastGeneration = true;
            }
    }

    public int[] bestGrid () {
        return grid;
    }

    public boolean changeSinceLastGeneration () {
        return changeSinceLastGeneration;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public int[][] getPopulation () {
        int[][] population = new int[1][1];
        population[0] = grid;
        return population;
    }


}
