package games.sudoku;

//import games.othello.BoardInterface;

import java.awt.*;
import java.awt.geom.Rectangle2D;

import utilities.JEasyFrame;

import javax.swing.*;

/**
 * Created by IntelliJ IDEA.
 * User: sml
 * Date: 11-Oct-2005
 * Time: 11:59:10
 * To change this template use File | Settings | File Templates.
 */
public class SudokuView extends JComponent {
    static Color bg = new Color(190, 190, 240); // dark yello?
    static Color white = Color.white;
    static Color black = Color.black;
    static Color playable = Color.black;
    static Color offBoard = new Color(0, 0, 64);
    static Color numberColor = Color.black;

    static Color thinColor = new Color(0, 0, 128); // navy?
    static Stroke thin = new BasicStroke(1);
    static Color thickColor = Color.black; // navy?
    static Stroke thick = new BasicStroke(3);


    // n * n grid
    static int n = SimonsSudoku.size;
    static int sub = SimonsSudoku.subGrid;

    // each square to be of this size
    static int size = 30;

    int h, w;
    int[] grid;

    public SudokuView(int[] g) {
        w = size * n;
        h = size * n;
        grid = g;
    }

    public static void display(String title, int[] grid) {
        // copy the grid
        int[] g = new int[grid.length];
        System.arraycopy(grid, 0, g, 0, g.length);
        SudokuView sv = new SudokuView(g);
        new JEasyFrame(sv, title, true).center();
    }



    public Dimension getPreferredSize() {
        return new Dimension(w, h);
    }

    public void paintComponent(Graphics g1) {
        Graphics2D g = (Graphics2D) g1;
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        // g.setTransform( AffineTransform.getShearInstance(1, 0));
        // g.transform( AffineTransform.getScaleInstance(1, 0.5));
        g.setColor(bg);
        g.fillRect(0, 0, w, h);
        for (int i = 0; i <= n; i++) {
            int t = i * size;
            if ((i % sub) == 0) {
                g.setColor(thickColor);
                g.setStroke(thick);
            } else {
                g.setColor(thinColor);
                g.setStroke(thin);
            }
            g.drawLine(0, t, w, t);
            g.drawLine(t, 0, t, h);
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (grid[i+j*n] > 0) {
                    g.setColor(numberColor);
                    String num = "" + grid[i+j*n];
                    FontMetrics fm = g.getFontMetrics();
                    Rectangle2D rect = fm.getStringBounds(num, g);
                    Rectangle r = rect.getBounds();
                    // System.out.println(num + "\t " +  r);
                    // xc and yc are where the string should be centred
                    int xc = i *size + size/2;
                    int yc = j * size + size/2;
                    int xd = xc - (r.x + r.width/2);
                    int yd = yc - (r.y + r.height/2);
                    g.drawString(num , xd, yd);
                }
            }
        }
    }
}
