package games.sudoku;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 19-Oct-2005
 * Time: 17:54:19
 * To change this template use File | Settings | File Templates.
 */
public class UniformSwapCrossover implements Crossover {

    int[] child;

    public int[] doCrossover (boolean[] fixed, int[] grid1, int[] grid2, int boxSize) {
        int rowLength = boxSize * boxSize;
        child = new int[grid1.length];
        System.arraycopy (grid1, 0, child, 0, grid1.length);
        for (int i = 0; i < rowLength; i++) {
            crossoverOneRow (fixed, grid1, grid2, i * rowLength, rowLength);
        }
        return child;
    }

    private void crossoverOneRow (boolean[] fixed, int[] grid1, int[] grid2, int offset, int rowLength) {
        int[] locus = new int[rowLength + 1];
        for (int i = 0; i < rowLength; i++) {
            locus[child[offset + i]] = i;
        }
        for (int i = offset; i < offset + rowLength; i++) {
            if (Math.random () < 0.5)  {
                swap (child, i, locus[grid2[i]] + offset);
                for (int b = 0; b < rowLength; b++) {
                    locus[child[offset + b]] = b;
                }
            }
        }
    }

    public static void swap(int[] grid, int i, int j) {
        int tmp = grid[i];
        grid[i] = grid[j];
        grid[j] = tmp;
    }
}
